import { Metadata, Http } from '@zeedhi/core';
import { Modal, ModalService } from '@zeedhi/common';
import { TekGrid } from '@zeedhi/teknisa-components-common';

export class AFBuyerModalController {
  private AFBuyerModal!: Modal;

  public async createAFBuyerModal() {
    this.AFBuyerModal = await ModalService.createFromJson('/modals/aFBuyerGridModal', true);
  }

  public destroyAFBuyerModal() {
    this.AFBuyerModal?.destroy();
  }

  public async openAFBuyerModal({ component }, seriesData) {
    const props = component.options.props;
    const gridRoute = props.gridRoute;
    await this.AFBuyerModal.show();
    const gridGroup = Metadata.getInstance<TekGrid>('aFBuyerGridGroup');
    gridGroup.title = `${component.options.fullTitle.text} > ${seriesData.name}`;
    
    let queryString = 'requestType=FilterData';
    queryString += `&OPERADOR=${seriesData.CDOPERADOR}`;
    queryString += `&IDCONFRECEBIMENTO=${seriesData.IDCONFRECEBIMENTO}`;
    queryString += `&NMESTADO=${seriesData.ESTADO}`;
    queryString += `&NMREGIAOGEO=${seriesData.REGIAO}`;
    
    Http.get(`/${gridRoute}?${queryString}`).then(({ data }) => {
      gridGroup.datasource.updateData(data.dataset.aFBuyerGridGroup);
    });
  }

  public closeAFBuyerModal() {
    this.AFBuyerModal.hide();
  }
}
