import {
  Metadata,
  Http,
} from '@zeedhi/core';
import {
  Modal,
  ModalService,
  SelectMultiple,
  Select,
  Form,
} from '@zeedhi/common';
import { TekGrid } from '@zeedhi/teknisa-components-common';

export class FormAddOperatorExModalController {
  private addOperatorEx!: Modal;

  public async createAddOperatorEx() {
    this.addOperatorEx = await ModalService.createFromJson('/modals/formAddOperatorExModal', true);
  }
  
  public async openAddOperatorEx() {
    await this.addOperatorEx.show();
    const data = Metadata.getInstance<TekGrid>('exceptionOperatorGrid').datasource.filter;
    const selectOp = Metadata.getInstance<SelectMultiple>('operatorsEx').datasource;
    if (data.NRINDICPAINEL) {
      (selectOp as any).route = '/crudN/operatorPanelProfile';
      selectOp.setFilter(data);
    } else {
      (selectOp as any).route = '/crudN/operatorPanelProfileEx';
      selectOp.setFilter(data);
    }
  }
  
  public closeAddOperatorEx() {
    const form = Metadata.getInstance<Form>('formExOp');
    form.clearForm();
    this.addOperatorEx.hide();
  }
  
  public saveOperatorEx() {
    const grid = Metadata.getInstance<TekGrid>('exceptionOperatorGrid');
    const operator = Metadata.getInstance<SelectMultiple>('operatorsEx');
    const cdfilial = Metadata.getInstance<Select>('CDFILIAL').value.CDFILIAL;
    const form = Metadata.getInstance<Form>('formExOp');
    const sendObject = {
      NRPERFACLPAINEL: null,
      NRINDICPAINEL: null,
      OPERATOR: null,
      CDFILIAL: null,
      NRPAINEL: null,
      IDVISUINDIC: null,
    };
    if (!grid.datasource.filter.NRINDICPAINEL) {
      sendObject.NRPERFACLPAINEL = grid.datasource.filter.NRPERFACLPAINEL;
      sendObject.CDFILIAL = cdfilial;
      sendObject.NRPAINEL = grid.datasource.filter.NRPAINEL;
      sendObject.OPERATOR = operator.value;
      Http.post('/insertExOperator', {
        requestType: 'Row',
        row: sendObject,
      }).then(() => {
        grid.datasource.get();
        form.clearForm();
        this.addOperatorEx.hide();
      });
    } else {
      sendObject.NRINDICPAINEL = grid.datasource.filter.NRINDICPAINEL;
      sendObject.OPERATOR = operator.value;
      Http.post('/saveExOperatorIndicator', {
        requestType: 'Row',
        row: sendObject,
      }).then(() => {
        grid.datasource.get();
        form.clearForm();
        this.addOperatorEx.hide();
      });
    }
  }
}
